/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.apps.component.cfw;

import java.io.File;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.List;
import java.util.Iterator;
import java.util.Enumeration;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.table.*;
import javax.swing.border.TitledBorder;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.ListSelectionEvent;

import gov.sns.application.*;

// rdbCore imports
import gov.anl.aps.irmis.persistence.pv.IOCBoot;
import gov.anl.aps.irmis.persistence.pv.IOCResource;
import gov.anl.aps.irmis.persistence.pv.Record;
import gov.anl.aps.irmis.persistence.pv.Field;

/**
 * Primary GUI for IRMIS Component Viewer application. All window layout, and Swing event
 * listeners are done here. Business logic work is delegated to <code>ComponentDocument</code>,
 * which in turn requests that the ComponentModel notify us here of changes to the data. In short,
 * we listen for <code>ComponentModelEvent</code> here.
 */
public class ComponentWindow extends XalInternalWindow {

	/** The main model for the document */
	final protected ComponentModel _model;

	// Swing GUI components
    private JPanel topPanel;
	
	/** 
	 * Creates a new instance of ComponentWindow
	 * @param aDocument The document for this window
	 */
    public ComponentWindow(final XalInternalDocument aDocument) {
        super(aDocument);

		_model = ((ComponentDocument)aDocument).getModel();

        // make ComponentWindow a listener for changes in ComponentModel
		_model.addComponentModelListener( new ComponentModelListener() {
                public void modified(ComponentModelEvent e) {
                    updateView(e);
                }
            });

        // initial application window size
        setSize(300, 80);

        // build contents
		makeContents();
    }

    /**
     * Top-level method to build up Swing GUI components.
     */
    public void makeContents() {

        // topmost organization (pv search above, results below)
        topPanel = new JPanel();
        topPanel.add(new JLabel("Component viewer coming soon..."));

    	getContentPane().add(topPanel);
    }

    /**
     * Update graphical view of PVModel data based on event type.
     *
     * @param event type of data model change
     */
    public void updateView(ComponentModelEvent event) {

    }

    /********************************************************************
     * Inner classes supporting Swing components
     ********************************************************************/

}
