#
# Schema for components
# 

drop table component;
create table component
  (
    component_id int not null primary key auto_increment,
    component_type_id int not null,
    component_name varchar(100),
    serial_num int,
    verif tinyint(1),
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;
    

# note - logical_order column is substitute for ln and ps columns
# note - location can be determined from housing hierarchy
drop table component_rel;
create table component_rel
  (
    component_rel_id int not null primary key auto_increment,
    parent_component_id int,
    child_component_id int,
    logical_order int,
    component_rel_type_id int
  ) type=InnoDb;

drop table component_rel_type;
create table component_rel_type
  (
    component_rel_type_id int not null primary key,
    rel_name varchar(30) 
  ) type=InnoDb;

# note - spare_loc_id should be fk to component which is of type "room" (or similar)
drop table component_type;
create table component_type
  (
    component_type_id int not null primary key auto_increment,
    component_type_name varchar(60),
    description varchar(100),
    form_factor_id int,
    mfg_id int,
    cog_person_id int,
    owns tinyint(1),
    spare_qty int,
    spare_loc_component_id int,
    stock_qty int,
    doc_uri_id int, 
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

drop table component_port;
create table component_port
  (
    component_port_id int not null primary key auto_increment,
    component_port_type_id int,
    component_id int,
    component_port_name varchar(40),
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

drop table component_port_type;
create table component_port_type
  (
    component_port_type_id int not null primary key auto_increment,
    component_port_type varchar(60),
    component_port_group varchar(60),
    component_port_pin_count int,
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;

drop table port_pin;
create table port_pin
  (
    port_pin_id int not null primary key auto_increment,
    port_pin_type_id int,
    port_pin_name varchar(60),
    port_pin_io_addr varchar(60),
    component_port_id int,
    port_pin_designator_id int,
    modified_date timestamp,
    modified_by varchar(10)
  ) type=InnoDb;




































