/*
   Copyright (c) 2004-2005 The University of Chicago, as Operator
   of Argonne National Laboratory.
*/
package gov.anl.aps.irmis.persistence.pv;

import gov.anl.aps.irmis.persistence.BaseDAO;
import gov.anl.aps.irmis.persistence.DAOException;

import java.util.List;

/**
 * Methods for finding/adding ioc attribute types.
 */
public class IOCAttributeTypeDAO extends BaseDAO {

    /**
     * Do nothing constructor.
     */
    public IOCAttributeTypeDAO() throws DAOException {
        super();
    }

    /**
     * Find set of all ioc attribute types from ioc_attr_type table.
     * 
     * @return list of <code>IOCAttributeType</code> objects
     * @throws DAOException
     */
    public List findIOCAttributeTypes() throws DAOException {
        return retrieveObjs("from IOCAttributeType iat order by iat.attributeType",null,null);
    }

    public void save(IOCAttributeType iat) throws DAOException {
        storeObj(iat);
    }

    public void delete(IOCAttributeType iat) throws DAOException {
        removeObj(iat);
    }

}
